<template>
  <el-dialog title="Edit panel" :visible.sync="dialogVisible" @close="cancelForm()" width="90%">
    <el-row>
      <el-col :md="12" style="padding: 10px">
        <el-form :model="panel">
          <el-form-item label="Name" required :error="errors.name">
            <el-input v-model="panel.name" prop="name"></el-input>
          </el-form-item>

          <el-form-item label="Location" required :error="errors.location">
            <el-select v-model="panel.location" style="width: 100%">
              <el-option label="Home" value="home"></el-option>
              <el-option label="Calls" value="calls"></el-option>
              <el-option label="Agents" value="agents"></el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="Display type" required :error="errors.display_type">
            <el-select v-model="panel.displayType" style="width: 100%">
              <el-option label="Table" value="table"></el-option>
              <el-option label="Pie" value="pie"></el-option>
              <el-option label="Column" value="column"></el-option>
              <el-option label="Bar" value="bar"></el-option>
              <el-option label="Line" value="line"></el-option>
              <el-option label="Scatter" value="scatter"></el-option>
              <el-option label="Area" value="area"></el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="Queries">
            <div v-for="query in panel.queries" :key="query.key">
              <el-input v-model="query.name" placeholder="Name"></el-input>
              <el-input type="textarea" v-model="query.query"></el-input>
              <div style="text-align: right">
                <el-button type="text" size="small" @click="removeQuery(query.id)">Remove</el-button><br/>
              </div>
            </div>
            <el-button type="text" @click="addQuery()">Add query</el-button><br/>
            <small>Available variables: <code>:start_time</code>, <code>:end_time</code>,
                                  <code>:call_id</code> & <code>:agent_id</code></small>
          </el-form-item>
        </el-form>
      </el-col>

      <el-col :md="12" style="padding: 10px">
        <h3>Preview</h3>

        <el-card>
          <div slot="header">
            <span>{{this.$data.panel.name}}</span>
            <el-button-group style="float: right; padding: 0 3px">
              <el-button plain size="mini">up</el-button>
              <el-button plain size="mini">down</el-button>
              <el-button plain size="mini">remove</el-button>
            </el-button-group>
          </div>
          
          <iframe style="border: 0; width: 100%" :src="panelURI()" @load="setPanelHeight($event)"></iframe>
        </el-card>
      </el-col>
    </el-row>

    <span slot="footer" class="dialog-footer">
      <el-button @click="cancelForm()">Cancel</el-button>
      <el-button @click="deletePanel()" type="danger">Delete</el-button>
      <el-button type="primary" @click="submitForm()">Save</el-button>
    </span>
  </el-dialog>
</template>

<script>
// import Ace from 'ace-builds'
import PanelQuery from '../../../graphql/queries/panel'
import UpdatePanelMutation from '../../../graphql/mutations/update_panel'
import DeletePanelMutation from '../../../graphql/mutations/delete_panel'

export default {
  apollo: {
    panel: {
      query: PanelQuery,
      variables(){
        return { id: this.$route.params.id }
      },
      update ({ panel }) {
        let queries = []
        if(panel.queries.length > 0 ){
          panel.queries.forEach((query) => { queries.push({ id: query.id, name: query.name, query: query.query }) })
        }
        else
          queries = this.$data.panel.queries
        return { id: panel.id, name: panel.name, location: panel.location, displayType: panel.displayType, queries: queries }
      }
    }
  },

  mounted () {
    this.$apollo.queries.panel.refetch()
  },

  data() {
    return {
      dialogVisible: true,
      panel: {
        id: null,
        name: '',
        location: 'home',
        displayType: 'table',
        queries: [{ id: 0, name: '', query: 'SELECT "Total calls", count(*) FROM calls WHERE made_at BETWEEN :start_time AND :end_time;' }]
      },
      errors: {
        name: '', location: '', display_type: ''
      }
    }
  },

  methods: {
    addQuery() {
      let last_id = this.$data.panel.queries.length > 0 ? this.$data.panel.queries[this.$data.panel.queries.length - 1].id : 1
      let id = last_id <= 0 ? last_id - 1 : 0
      this.$data.panel.queries.push({ id: id, name: '', query: 'SELECT "Total calls", count(*) FROM calls WHERE made_at BETWEEN :start_time AND :end_time;' })
    },
    removeQuery(id) {
      if(this.$data.panel.queries.length > 1 ) {
        this.$data.panel.queries.forEach((query, index, array) => {
          if(query.id == id)
            this.$data.panel.queries.splice(index, 1)
        })
      }
    },
    panelURI() {
      let uri = `/panels/preview?location=${this.$data.panel.location}&display_type=${this.$data.panel.displayType}`
      this.$data.panel.queries.forEach((query) => {
        uri += `&queries[name][]=${query.name}&queries[query][]=${query.query}`
      })
      return uri
    },
    setPanelHeight(event) {
      let iframe = event.target
      let iframeWin = iframe.contentWindow || iframe.contentDocument.parentWindow
      iframe.style.height = `${iframeWin.document.documentElement.scrollHeight || iframeWin.document.body.scrollHeight}px`
    },
    submitForm() {
      this.$apollo.mutate({
        mutation: UpdatePanelMutation,
        variables: { panel: this.$data.panel },
        update: (store, { data: { updatePanel } }) => {
          if(updatePanel.success) {
            this.$message.success('Panel updated successfully')
            this.$data.dialogVisible = false
            this.$router.push('/admin/panels')
          }
          else{
            this.$message.error('Failed to update panel')
            updatePanel.errors.forEach(error => { this.$data.errors[error.field] = error.message })
          }
        }
      })
    },
    deletePanel() {
      this.$confirm('Are you sure you want to delete this panel?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(() => {
        this.$apollo.mutate({
          mutation: DeletePanelMutation,
          variables: { panel: { id: this.$route.params.id } },
          update: (store, { data: { deletePanel } }) => {
            if(deletePanel.success) {
              this.$message.success('Panel deleted successfully')
              this.$data.dialogVisible = false
              this.$router.push('/admin/panels')
            }
            else{
              this.$message.error('Failed to delete panel')
              deletePanel.errors.forEach(error => { this.$data.errors[error.field] = error.message })
            }
          }
        })
      })
    },
    cancelForm() {
      this.$data.dialogVisible = false
      this.$router.push('/admin/panels')
    }
  }
}
</script>
